#ifndef GUI_HH
#define GUI_HH

/*
  James R. Diebel
  Stanford University

  Started: 30 August 2004
  Last revised: 30 Sugust 2004

  gui.hh - defines GUI namespace and set of methods that contains
  functionality required to create a graphical user interface to view a
  Mesh object (MSH file)

  Depends on:
  - Mesh class (mesh.hh)
  -- Vec3d class (vec3d.hh)
  -- Vert class (vert.hh)
  -- Edge class (edge.hh)
  -- Face class (face.hh)
*/

#include "mesh.hh"
#include <GL/glut.h>
#include "glui.h"

using namespace std;
using namespace bmtk;

// Methods
int startGUI(Mesh* m_);
void controlCB(int control);
void myGlutKeyboard(unsigned char Key, int x, int y);
void myGlutMenu(int value);
void myGlutIdle(void);
void myGlutMouse(int button, int button_state, int x, int y);
void myGlutMotion(int x, int y);
void myGlutReshape(int x, int y);
void drawMesh(void);
void update();
void takeScreenShot();
void myGlutDisplay(void);
int startGUI(Mesh *m_);
void saveOptions();
void loadOptions();

#endif
