/*
  James R. Diebel
  Stanford University
  
  Started: 24 August 2004
  Last revised: 27 Sugust 2004

  ply2msh.cc - Utility to convert a PLY file to a mesh (MSH) file

  Depends on:
  - Mesh class (mesh.hh)
  -- Vec3d class (vec3d.hh)
  -- Vert class (vert.hh)
  -- Edge class (edge.hh)
  -- Face class (face.hh)
  - Timer class (timer.hh)
  - TriMesh class (trimesh.h)
*/


#include <iostream>
#include "bmtk/mesh.hh"
#include "bmtk/timer.hh"

using namespace std;

int main (int argc, char *argv[]) {
  // if bad command line args, give usage instructions and exit
  if (argc < 2) {
    cout << endl << "Usage: console file " << endl;
    exit(1);
  }
  
  // start stopwatch
  Timer t("","\n");
  t.start();
  t.printMark("Start");

  // read back mesh to make sure things are working ok
  Mesh m;
  m.readMesh(argv[1]);
  t.printMark("Reading mesh from file");

  // give final time and return success
  t.printStore();
  return 0;
}
